#include <windows.h>
#include "runtime.h"
#include "bit.h"
#include "smaf.h"

static SMAFCALLBACK SMAFCallBack = NULL;
static HWND MPWnd = NULL;	// MessageboxParentWND

void SetSMAFCallBack(SMAFCALLBACK scb)
{
	SMAFCallBack = scb;

	return;
}

void SetSMAFMPWnd(HWND hWnd)
{
	MPWnd = hWnd;

	return;
}

BOOL findchunk4(BYTE* data, DWORD dsize, char* cname, CHUNK* ch)
{
	DWORD cur;

	for(cur = 0; cur < dsize; )
	{
		if(!memcomp(data + cur, cname, 4))
		{
			ch->data = data + cur + 8;
			ch->size = SwapDword(data + cur + 4);
			return TRUE;
		}
		cur += 8 + SwapDword(data + cur + 4);
	}

	return FALSE;
}

BOOL findchunk3(BYTE* data, DWORD dsize, char* cname, CHUNK* ch)
{
	DWORD cur;

	for(cur = 0; cur < dsize; )
	{
		if(!memcomp(data + cur, cname, 3))
		{
			ch->data = data + cur + 8;
			ch->size = SwapDword(data + cur + 4);
			return TRUE;
		}
		cur += 8 + SwapDword(data + cur + 4);
	}

	return FALSE;
}

UINT SetVValAndForward(BYTE** pdata, DWORD s)
{
	UINT wbytes = 0;

	if(0x1FFFFF < s)
		*(*pdata)++ = (BYTE)(((s >> 21) & 0x7F) | 0x80), s &= 0x1FFFFF, wbytes++;
	if(0x3FFF < s)
		*(*pdata)++ = (BYTE)(((s >> 14) & 0x7F) | 0x80), s &= 0x3FFF, wbytes++;
	if(0x7F < s)
		*(*pdata)++ = (BYTE)(((s >> 7) & 0x7F) | 0x80), s &= 0x7F, wbytes++;

	*(*pdata)++ = (BYTE)(s & 0x7F), wbytes++;

	return wbytes;
}

UINT SetVVal(BYTE* pdata, DWORD s)
{
	UINT wbytes = 0;

	if(0x1FFFFF < s)
		*pdata++ = (BYTE)(((s >> 21) & 0x7F) | 0x80), s &= 0x1FFFFF, wbytes++;
	if(0x3FFF < s)
		*pdata++ = (BYTE)(((s >> 14) & 0x7F) | 0x80), s &= 0x3FFF, wbytes++;
	if(0x7F < s)
		*pdata++ = (BYTE)(((s >> 7) & 0x7F) | 0x80), s &= 0x7F, wbytes++;

	*pdata++ = (BYTE)(s & 0x7F), wbytes++;

	return wbytes;
}

UINT SetVValSize(DWORD s)
{
	UINT wbytes = 0;

	if(0x1FFFFF < s)
		s &= 0x1FFFFF, wbytes++;
	if(0x3FFF < s)
		s &= 0x3FFF, wbytes++;
	if(0x7F < s)
		s &= 0x7F, wbytes++;

	wbytes++;

	return wbytes;
}

DWORD GetVValAndForward(BYTE** pdata)
{
	DWORD val = 0;

	do
	{
		val <<= 7;
		val |= **pdata & 0x7F;
	}while(*(*pdata)++ & 0x80);

	return val;
}

DWORD GetVValSize(BYTE* pdata)
{
	BYTE* p = pdata;

	do
	{
		;
	}while(*p++ & 0x80);

	return p - pdata;
}

DWORD GetVValAndForward4HPS(BYTE** pdata)
{
	DWORD val = 0;

	if(**pdata & 0x80)
		val = (((*(*pdata)++) & 0x7F) + 1) << 7;

	val |= *(*pdata)++;

	return val;
}

DWORD GetVVal(BYTE* pdata)
{
	DWORD val = 0;

	do
	{
		val <<= 7;
		val |= *pdata & 0x7F;
	}while(*pdata++ & 0x80);

	return val;
}

UINT getGateTime(EVENT* e)
{
	if((e->status & 0xF0) == 0x80)
		return GetVVal(e->data + 1);
	if((e->status & 0xF0) == 0x90)
		return GetVVal(e->data + 2);

	return 0;
}

void ClearEvents(SMAF* smaf)
{
	EVENT* e = smaf->events;

	while(e)
	{
		EVENT* next = e->next;
		if(e->data)
			hfree(e->data);
		hfree(e);
		e = next;
	}

	smaf->events = NULL;
	smaf->start = NULL;
	smaf->stop = NULL;

	return;
}

void InsertEvent(SMAF* smaf, EVENT* e)
{
	EVENT* preev = NULL;
	EVENT* ev = smaf->events;
	EVENT* enx;

	while(ev)
	{
		if(e->time < ev->time)
			break;
		preev = ev;
		ev = ev->next;
	}

	if(!preev)
	{
		// insert top(smafevents->"here"->ev)
		smaf->start = e;
		if(!smaf->events)
		{
			enx = NULL;	// NoEntry
		}else
		{
			enx = smaf->events;
			enx->duration -= e->time;
		}
		e->duration = e->time;
		smaf->events = e;
	}else
	{	// insert preev->"here"->ev
		enx = preev->next;
		preev->next = e;

		e->duration = e->time - preev->time;
		if(ev)
			ev->duration -= e->duration;
	}

	e->next = enx;

	return;
}

EVENT* CutoutEvent(SMAF* smaf, EVENT* e)
{
	EVENT* ev = smaf->events;
	EVENT* preev = NULL;

	if(ev)
		while(ev != e && ev)
		{
			preev = ev;
			ev = ev->next;
		}

	if(ev == e)
	{
		if(!preev)
			smaf->events = ev->next;
		else
			preev->next = ev->next;
		if(smaf->start == ev)
			smaf->start = ev->next;

		if(ev->next)
			ev->next->duration += ev->duration;
	}

	return e;
}

// for HPS: convert to MSF
void ConvertEvents2(SMAF* smaf, BYTE* data, DWORD size, BOOL fsetup, DWORD start, DWORD stop, UINT chshift)
{
	BYTE* p;
	DWORD tdur = 0;
	signed int octshift[4] = {0};
	UINT scbcnt = 0;

	BOOL started = FALSE;
	BOOL stoped = FALSE;

	if(SMAFCallBack)
		SMAFCallBack(0, size, SCBSTATE_BEGIN);

	for(p = data; p < data + size; )
	{
		EVENT* e;
		UINT esize = 1;	// command size
		BYTE* topp = p;

		if(SMAFCallBack && scbcnt++ == 100)
		{
			SMAFCallBack(p - data, size, SCBSTATE_PROCESSING);
			scbcnt = 0;
		}

		e = halloc(sizeof(EVENT));
		if(fsetup)
			e->duration = 0;
		else
			e->duration = GetVValAndForward4HPS(&p) * smaf->dbase;
		tdur += e->duration;
		e->time = tdur;
		e->status = 0;
		e->size = 0;
		e->data = NULL;

		if(!fsetup)
		{
			if(!smaf->start && (DWORD)(topp - data) == start)
				smaf->start = e;
			if(!smaf->stop && (DWORD)(topp - data) == stop)
				smaf->stop = e;
		}

		// Parse status!!
		if(p[0] == 0xFF && p[1] == 0xF0)	// Exclusive
		{
			esize = 2 + 1 + p[2];
			// need exclusive convert
#if 1
			e->size = 1 + p[2];
			e->status = 0xF0;
			e->data = halloc(e->size);
			memcopy(e->data, p + 2, e->size);
#else
			hfree(e);
			p += esize;
			continue;
#endif
		}else if(p[0] == 0xFF && p[1] == 0x00)	// NOP
		{
			esize = 2;
			e->size = 1;
			e->data = halloc(e->size);
			e->status = 0xFF;
			e->data[0] = 0x00;
		}else
		{
			if(p[0] != 0x00)	// Note
			{
				BYTE ch;
				BYTE oct;
				BYTE note;
				BYTE absnote;

				ch = (p[0] >> 6 & 0x03);
				oct = p[0] >> 4 & 0x03;
				note = p[0] & 0x0F;
				// MIDI's 69 = 440Hz(A) = Oct2,9
				absnote = 36 + (oct + octshift[ch]) * 12 + note;

				e->status = 0x80 | (ch + chshift);

				{
					BYTE* q = p + 1;
					DWORD gt;

					gt = GetVValAndForward4HPS(&q) * smaf->gbase;
					esize = q - p;
					/*
					{
						DWORD siz;
						siz = q - p;
						if(siz == 1 + 2 && p[1] == 0xFF)	// vval over 2byte.
							siz++;
						e->size = siz;
					}
					*/
					e->size = 1 + SetVValSize(gt);
					e->data = halloc(e->size);

					e->data[0] = absnote;
					/*
					if(p[1] & 0x80)
					{
						if(p[1] == 0xFF)
						{
							e->data[1] = 0x80;
							e->data[2] = p[1] + 1;
							e->data[3] = p[2];
						}else
						{
							e->data[1] = p[1] + 1;
							e->data[2] = p[2];
						}
					}else
						e->data[1] = p[1];
					*/
					SetVVal(e->data + 1, gt);
				}
			}else
			{
				BYTE ch;
				ch = (p[1] >> 6 & 0x03) + chshift;

				if(p[1] == 0x00 && p[2] == 0x00 && p[3] == 0x00)	// EOS?
					esize = 4;
				if((p[1] & 0x30) == 0x30)
				{
					if((p[1] & 0x0F) == 0x00)	// Program Change
					{
						esize = 3;
						e->size = 1;
						e->data = halloc(e->size);
						e->status = 0xC0 | ch;
						e->data[0] = p[2];
					}
					if((p[1] & 0x0F) == 0x01)	// Bank Select
					{
						esize = 3;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xB0 | ch;
						e->data[0] = 0x00;	// banksel
						e->data[1] = p[2];
					}
					if((p[1] & 0x0F) == 0x02)	// Octave Shift
					{
						UINT ch = p[0] >> 6 & 0x03;

						esize = 3;
						if(0x01 <= p[2] && p[2] <= 0x04)
							octshift[ch] = p[2];
						if(0x81 <= p[2] && p[2] <= 0x84)
							octshift[ch] = -(p[2] - 0x80);

#if 1
						// NOP
						e->size = 1;
						e->data = halloc(e->size);
						e->status = 0xFF;
						e->data[0] = 0x00;
#else
						hfree(e);
						p += esize;

						continue;
#endif
					}
					if((p[1] & 0x0F) == 0x03)	// Modulation
					{
						esize = 3;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xB0 | ch;
						e->data[0] = 0x01;	// mod.
						e->data[1] = p[2];
					}
					if((p[1] & 0x0F) == 0x04)	// PitchBend
					{
						esize = 3;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xE0 | ch;
						e->data[0] = 0x00;
						e->data[1] = p[2];	// tenuki.
					}
					if((p[1] & 0x0F) == 0x07)	// Volume
					{
						esize = 3;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xB0 | ch;
						e->data[0] = 0x07;	// vol
						e->data[1] = p[2];
					}
					if((p[1] & 0x0F) == 0x0A)	// Pan
					{
						esize = 3;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xB0 | ch;
						e->data[0] = 0x0A;	// pan
						e->data[1] = p[2];
					}
					if((p[1] & 0x0F) == 0x0B)	// Expression
					{
						esize = 3;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xB0 | ch;
						e->data[0] = 0x0B;	// exp.
						e->data[1] = p[2];
					}
				}else
				{
					if((p[1] & 0x30) == 0x00)	// Expression
					{
						esize = 2;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xB0 | ch;
						e->data[0] = 0x0B;	// exp.
						e->data[1] = (p[1] & 0xF0) << 3;
					}
					if((p[1] & 0x30) == 0x10)	// PitchBend
					{
						esize = 2;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xE0 | ch;
						e->data[0] = 0x00;
						e->data[1] = (p[1] & 0xF0) << 3;	// chou tenuki
					}
					if((p[1] & 0x30) == 0x20)	// Modulation
					{
						esize = 2;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xB0 | ch;
						e->data[0] = 0x01;	// mod.
						e->data[1] = (p[1] & 0xF0) << 3;
					}
				}
			}
		}

		if(esize == 1)
		{
			TCHAR ts[256];

			wsprintf(ts, "What's this? %02X", p[0]);
			MessageBox(MPWnd, ts, "Error", MB_ICONERROR | MB_OK);
		}

		p += esize;

		InsertEvent(smaf, e);

		/*
		if(started)
		{
			smaf->start = e;
			started = FALSE;
		}
		if(stoped)
		{
			smaf->stop = e;
			stoped = FALSE;
		}
		*/
	}

	if(!fsetup && !smaf->start)
		smaf->start = smaf->events;

	if(SMAFCallBack)
		SMAFCallBack(0, size, SCBSTATE_FINISH);

	return;
}

// for MSF
void ConvertEvents(SMAF* smaf, BYTE* data, DWORD size, BOOL fsetup, DWORD start, DWORD stop)
{
	BYTE* p;
	DWORD tdur = 0;
	UINT scbcnt = 0;

	BOOL started = FALSE;
	BOOL stoped = FALSE;

	if(SMAFCallBack)
		SMAFCallBack(0, size, SCBSTATE_BEGIN);

	for(p = data; p < data + size; )
	{
		EVENT* e;
		BYTE* topp = p;
		int esize = 0;

		if(SMAFCallBack && scbcnt++ == 100)
		{
			SMAFCallBack(p - data, size, SCBSTATE_PROCESSING);
			scbcnt = 0;
		}

		e = halloc(sizeof(EVENT));
		if(fsetup)
			e->duration = 0;
		else
			e->duration = GetVValAndForward(&p) * smaf->dbase;
		tdur += e->duration;
		e->time = tdur;
		e->status = *p++;
		e->size = 0;
		e->data = NULL;

		if(!fsetup)
		{
			if((DWORD)(topp - data) == start)
				smaf->start = e;
			if((DWORD)(topp - data) == stop)
				smaf->stop = e;
		}

		// Parse status!!
		if((e->status & 0xF0) == 0x80)	// Note w/o verocity: convert gate time
		{
			DWORD gt = GetVVal(p + 1) * smaf->gbase;
			e->size = 1 + SetVValSize(gt);
			e->data = halloc(e->size);
			e->data[0] = p[0];
			SetVVal(e->data + 1, gt);

			esize = -(1 + (int)GetVValSize(p + 1));
		}
		if((e->status & 0xF0) == 0x90)	// Note w/ verocity: convert gate time
		{
			DWORD gt = GetVVal(p + 2) * smaf->gbase;
			e->size = 2 + SetVValSize(gt);
			e->data = halloc(e->size);
			e->data[0] = p[0];
			e->data[1] = p[1];
			SetVVal(e->data + 2, gt);

			esize = -(2 + (int)GetVValSize(p + 2));
		}
		if((e->status & 0xF0) == 0xA0)	// Resv 3byte
		{
			esize = 3;
		}
		if((e->status & 0xF0) == 0xB0)	// Control Change
		{
			esize = 2;
		}
		if((e->status & 0xF0) == 0xC0)	// Program Change
		{
			esize = 1;
		}
		if((e->status & 0xF0) == 0xD0)	// Resv 2byte
		{
			esize = 2;
		}
		if((e->status & 0xF0) == 0xE0)	// PitchBend
		{
			esize = 2;
		}
		if(e->status == 0xF0)	// Exclusive
		{
			BYTE* q = p;

			esize = GetVValAndForward(&q);
			esize += (q - p);	// VVal size
		}
		if(e->status == 0xFF)	// NOP or EOS
		{
			if(*p == 0x00)
				esize = 1;
			if(*p == 0x2F)
				esize = 2;
		}

		// copy.
		if(esize < 0)
		{
			p += -esize;
		}else if(esize > 0)
		{
			e->size = esize;
			e->data = halloc(esize);
			memcopy(e->data, p, esize);
			p += esize;
		}else
			MessageBox(MPWnd, "ConvertEvents(MSF-import): Program's bug or Illegal SMAF file", "What the hell...?", MB_OK);

		InsertEvent(smaf, e);
	}

	// SMAFt@CoOĂ鎞̋~...ˁ[B
	if(!fsetup && !smaf->start)
		smaf->start = smaf->events;

	if(SMAFCallBack)
		SMAFCallBack(0, size, SCBSTATE_FINISH);

	return;
}

SMAF* FreeSmaf(SMAF* smaf)
{
	if(!smaf)
	{
		MessageBox(MPWnd, "already smaf == NULL", "BUG?", MB_ICONERROR | MB_OK);
		return NULL;
	}

	if(smaf->data)
		hfree(smaf->data);

	ClearEvents(smaf);

	hfree(smaf);

	return NULL;
}

BOOL ReloadSmaf(SMAF* smaf)
{
	ClearEvents(smaf);

	{
		CHUNK chk;
		CHUNK mtr;
		DWORD chkplus;
		DWORD chshift;

		if(!findchunk4(smaf->data, smaf->size, "MMMD", &chk))
		{
			MessageBox(MPWnd, "This is not SMAF", "Error", MB_ICONERROR | MB_OK);
			return FALSE;
		}

		chk.size -= 2;	// MMMD's CRC

		// MTRւ̑Ή
		for(chkplus = 0, chshift = 0; chkplus < chk.size; chshift += 4)
		{
			if(!findchunk3(chk.data + chkplus, chk.size, "MTR", &mtr))
				break;

			chkplus = (mtr.data - chk.data) + mtr.size;

			{
				CHUNK dummy;

				switch(mtr.data[2])
				{
				case 0x00: smaf->dbase = 1; break;
				case 0x01: smaf->dbase = 2; break;
				case 0x02: smaf->dbase = 4; break;
				case 0x03: smaf->dbase = 5; break;
				case 0x10: smaf->dbase = 10; break;
				case 0x11: smaf->dbase = 20; break;
				case 0x12: smaf->dbase = 40; break;
				case 0x13: smaf->dbase = 50; break;
				default: MessageBox(MPWnd, "Unknown duration timebase", "Error", MB_ICONERROR | MB_OK); return FALSE;
				}

				switch(mtr.data[3])
				{
				case 0x00: smaf->gbase = 1; break;
				case 0x01: smaf->gbase = 2; break;
				case 0x02: smaf->gbase = 4; break;
				case 0x03: smaf->gbase = 5; break;
				case 0x10: smaf->gbase = 10; break;
				case 0x11: smaf->gbase = 20; break;
				case 0x12: smaf->gbase = 40; break;
				case 0x13: smaf->gbase = 50; break;
				default: MessageBox(MPWnd, "Unknown gatetime timebase", "Error", MB_ICONERROR | MB_OK); return FALSE;
				}

				if(mtr.data[0] == 0x00)	// HPS
				{
					DWORD start, stop;

					MessageBox(MPWnd, "Notice: This is written in HPS format, MMF Tool can't convert accurately. Sorry.\n(This message will appear several times.)", "Notice", MB_ICONASTERISK | MB_OK);

					mtr.data += 4 + 2;	// skip ChStatus

					// init start,stop.
					if(findchunk4(mtr.data, mtr.size, "Mtsq", &dummy))
					{
						start = 0;
						stop = mtr.size;
					}

					if(findchunk4(mtr.data, mtr.size, "Mtsu", &dummy))
						ConvertEvents2(smaf, dummy.data, dummy.size, TRUE, 0, 0, chshift);

					if(findchunk4(mtr.data, mtr.size, "MspI", &dummy))
					{
						BYTE* p = dummy.data;

						while(p < dummy.data + dummy.size)
						{
							if(*p == 's' && *(p + 1) == 't')
							{
								p += 3;
								start = SwapDword(p);
								p += 4;
							}
							if(*p == 's' && *(p + 1) == 'p')
							{
								p += 3;
								stop = SwapDword(p);
								p += 4;
							}
							if(*p != ',')
								break;
							p++;
						}
					}

					if(findchunk4(mtr.data, mtr.size, "Mtsq", &dummy))
						ConvertEvents2(smaf, dummy.data, dummy.size, FALSE, start, stop, chshift);
				}

				if(mtr.data[0] == 0x01 || mtr.data[0] == 0x02)	// MSF
				{
					DWORD start, stop;

					mtr.data += 4 + 16;

					// init start,stop.
					if(findchunk4(mtr.data, mtr.size, "Mtsq", &dummy))
					{
						start = 0;
						stop = mtr.size;
					}

					if(findchunk4(mtr.data, mtr.size, "Mtsu", &dummy))
						ConvertEvents(smaf, dummy.data, dummy.size, TRUE, 0, 0);

					if(findchunk4(mtr.data, mtr.size, "MspI", &dummy))
					{
						BYTE* p = dummy.data;

						while(p < dummy.data + dummy.size)
						{
							if(*p == 's' && *(p + 1) == 't')
							{
								p += 3;
								start = SwapDword(p);
								p += 4;
							}
							if(*p == 's' && *(p + 1) == 'p')
							{
								p += 3;
								stop = SwapDword(p);
								p += 4;
							}
							if(*p != ',')
								break;
							p++;
						}
					}

					if(findchunk4(mtr.data, mtr.size, "Mtsq", &dummy))
					{
						if(mtr.data[-20] == 0x01)
						{
							BYTE* data;

							data = halloc(SwapDword(dummy.data));
							if(!huffmanDecode(data, dummy.data + 4, SwapDword(dummy.data), dummy.size))
							{
								hfree(data);
								MessageBox(MPWnd, "SMAF: LoadSmaf: huffmanDecode failed", "Error", MB_ICONERROR | MB_OK);
								return FALSE;;
							}
							ConvertEvents(smaf, data, SwapDword(dummy.data), FALSE, start, stop);
							hfree(data);
						}
						if(mtr.data[-20] == 0x02)
							ConvertEvents(smaf, dummy.data, dummy.size, FALSE, start, stop);
					}
				}
			}
		}
	}

	// TODO: delete this code after fix.
	{
		EVENT* ev;

		for(ev = smaf->events; ev; ev = ev->next)
			if(ev->status == 0xF0)
				if(ev->data[0] == 0x12 || ev->data[0] == 0x1F || ev->data[0] == 0x2A)
				{
					MessageBox(MPWnd, "Notice: There are some VoiceSet Exclusives, but MMF Tool can't emulate accurately. Use EmuPlay to play accrately.", "Notice", MB_ICONASTERISK | MB_OK);
					break;
				}
	}

	return TRUE;
}

SMAF* CreateSmaf(UINT dbase, UINT gbase)
{
	SMAF* smaf;

	if(!(smaf = halloc(sizeof(SMAF))))
		return NULL;

	smaf->readonly = FALSE;

	smaf->data = NULL;
	smaf->events = NULL;

	smaf->start = NULL;
	smaf->stop = NULL;

	smaf->dbase = dbase;
	smaf->gbase = gbase;

	return smaf;
}

SMAF* LoadSmaf(LPCTSTR fname)
{
	SMAF* smaf = NULL;
	HANDLE hf = NULL;
	DWORD read;

	if(!(smaf = CreateSmaf(0, 0)))	// ŕϊ̂0OKB
		goto Error;

	if((hf = CreateFile(fname, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) == INVALID_HANDLE_VALUE)
	{
		TCHAR ts[MAX_PATH + 80];

		wsprintf(ts, "Can't open %s", fname);
		MessageBox(MPWnd, ts, "Error", MB_ICONERROR | MB_OK);

		goto Error;
	}

	smaf->size = GetFileSize(hf, NULL);

	if(!(smaf->data = halloc(smaf->size)))
	{
		MessageBox(MPWnd, "Can't alloc memory", "Error", MB_ICONERROR | MB_OK);
		goto Error;
	}
	if(!ReadFile(hf, smaf->data, smaf->size, &read, NULL))
	{
		read = 0;
	}
	if(read < smaf->size)
	{
		MessageBox(MPWnd, "Couldn't read file.", "Error", MB_ICONERROR | MB_OK);
		goto Error;
	}

	CloseHandle(hf);

	if(!ReloadSmaf(smaf))
		goto Error;

	return smaf;
Error:
	if(smaf)
	{
		FreeSmaf(smaf);
	}
	if(hf)
	{
		CloseHandle(hf);
	}

	return NULL;
}

BYTE* CompileSmaf(SMAF* smaf, DWORD* datasize)
{
	BYTE* data;
	BYTE* p;

	p = data = halloc(1048576);	//߂ǂ

	{
		BYTE* cs = p;
		memcopy(p, "MMMD", 4);	p += 4;
		// Ƃ肠skip
		p += 4;

		{
			BYTE* cs = p;
			memcopy(p, "CNTI", 4);	p += 4;
			p += 4;

			*p++ = 0x00;	// CClass: YAMAHA
			*p++ = 0x32;	// CT: RingMelo: 悭킩B
			*p++ = 0x00;	// CCT: SJIS
			*p++ = 0xF8;	// CS: Edit Save Trans OK!
			*p++ = 0x00;	// CCnt: 0

			StoreBEDword(cs + 4, p - cs - 8);
		}

		// TODO:OPDA...

		{
			BYTE* cs = p;
			// 05MA-3A06MA-5Ă?
			memcopy(p, "MTR\x05", 4);	p += 4;
			p += 4;

			*p++ = 0x02;	// MobileStandardFormat(NoCompress)
			*p++ = 0x00;	// StreamSequence
			switch(smaf->dbase)	// TB-D
			{
			case 1:		*p++ = 0x00;	break;
			case 2:		*p++ = 0x01;	break;
			case 4:		*p++ = 0x02;	break;
			case 5:		*p++ = 0x03;	break;
			case 10:	*p++ = 0x10;	break;
			case 20:	*p++ = 0x11;	break;
			case 40:	*p++ = 0x12;	break;
			case 50:	*p++ = 0x13;	break;
			}
			switch(smaf->gbase)	// TB-G
			{
			case 1:		*p++ = 0x00;	break;
			case 2:		*p++ = 0x01;	break;
			case 4:		*p++ = 0x02;	break;
			case 5:		*p++ = 0x03;	break;
			case 10:	*p++ = 0x10;	break;
			case 20:	*p++ = 0x11;	break;
			case 40:	*p++ = 0x12;	break;
			case 50:	*p++ = 0x13;	break;
			}

			{
				int i;

				for(i = 0; i < 16; i++)
					*p++ = 0x00;	// chstatus... TODO: Edit here
			}

			{
				EVENT* e = smaf->events;

				{
					BYTE* cs = p;
					memcopy(p, "Mtsu", 4);	p += 4;
					p += 4;

					while(e && e->status == 0xF0 && e->time == 0)
					{
						// MasterVolume must in Mtsq.
						if(!memcomp(e->data, "\x07\x43\x79\x06\x7F\x00", 6))
							break;

						*p++ = 0xF0;
						memcopy(p, e->data, e->size);
						p += e->size;
						e = e->next;
					}

					if(p - cs - 8 == 0)
						p = cs;		// Mtsu not need
					else
						StoreBEDword(cs + 4, p - cs - 8);
				}

				{
					BYTE* cs = p;
					memcopy(p, "Mtsq", 4);	p += 4;
					p += 4;

					{
						UINT pret = 0;
						while(e)
						{
							SetVValAndForward(&p, (e->time - pret) / smaf->dbase);

							pret = e->time;
							*p++ = e->status;
							switch(e->status & 0xF0)
							{
							case 0x80:
								{
									DWORD val;
									*p++ = e->data[0];
									val = GetVVal(e->data + 1);
									SetVValAndForward(&p, val / smaf->gbase);
								}
								break;
							case 0x90:
								{
									DWORD val;
									*p++ = e->data[0];
									*p++ = e->data[1];
									val = GetVVal(e->data + 2);
									SetVValAndForward(&p, val / smaf->gbase);
								}
								break;
							default:
								memcopy(p, e->data, e->size);
								p += e->size;
								break;
							}
							e = e->next;
						}
					}

					StoreBEDword(cs + 4, p - cs - 8);
				}
			}

			StoreBEDword(cs + 4, p - cs - 8);
		}

		StoreBEDword(cs + 4, p - cs - 8 + 2);	// +2 = CRC

		{
			WORD crc = 0xFFFF;
			int i, j; 
			BYTE *buf = cs;  
			for (i = 0; i < p - cs; i++)
			{
				crc ^= (buf[i] << 8); 	
				for (j = 0; j < 8; j++)
 					if (crc & 0x8000U)
						 crc = (crc << 1) ^ /*CRCPoly*/0x1021U;
 					else
						crc <<= 1;
			}

			StoreBEWord(p, ~crc);
		}
	}

	if(datasize)
		*datasize = p + 2 - data;

	return data;
}
