#include <windows.h>
#include "runtime.h"
#include "version.h"

void getVersion(VERSION* v)
{
	char name[MAX_PATH + 1];
	char* vi;
	DWORD size;

	v->major = 0;
	v->minor = 0;
	v->patch = 0;
	v->build = 0;

	GetModuleFileName(NULL, name, MAX_PATH);
	size = GetFileVersionInfoSize(name, 0);
	if(!(vi = halloc(size)))
		return;

	GetFileVersionInfo(name, 0, size, vi);
	{
		VS_FIXEDFILEINFO* ver;

		if(!VerQueryValue(vi, "\\", &ver, NULL))
		{
			hfree(vi);
			return;
		}

		// nameg
		v->major = HIWORD(ver->dwFileVersionMS);
		v->minor = LOWORD(ver->dwFileVersionMS);
		v->patch = HIWORD(ver->dwFileVersionLS);
		v->build = LOWORD(ver->dwFileVersionLS);
	}

	hfree(vi);

	return;
}
